vsg: vsg::Viewer Class Reference

vsg 1.1.8 VulkanSceneGraph library

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | Static Public Attributes | Protected Attributes | List of all members
vsg::Viewer Class Reference

`#include <Viewer.h>`

Inheritance diagram for vsg::Viewer:
[legend]
Collaboration diagram for vsg::Viewer:
[legend]

## Public Types
using | Presentations = std::vector<ref_ptr<Presentation>>

## Public Member Functions
| Viewer (const Viewer &)=delete
Viewer & | operator= (const Viewer &rhs)=delete
virtual void | addWindow (ref_ptr< Window > window)
| add Window to Viewer
virtual void | removeWindow (ref_ptr< Window > window)
| remove Window from Viewer
Windows & | windows ()
const Windows & | windows () const
clock::time_point & | start_point ()
const clock::time_point & | start_point () const
FrameStamp * | getFrameStamp ()
const FrameStamp * | getFrameStamp () const
bool | active () const
| return true if viewer is valid and active
virtual void | close ()
| schedule closure of the viewer and associated windows, after a call to Viewer::close() the Viewer::active() method will return false
virtual bool | pollEvents (bool discardPreviousEvents=true)
| poll the events for all attached windows, return true if new events are available
UIEvents & | getEvents ()
| get the current set of Events that are filled in by prior calls to pollEvents
const UIEvents & | getEvents () const
| get the const current set of Events that are filled in by prior calls to pollEvents
void | addEventHandler (ref_ptr< Visitor > eventHandler)
| add event handler
void | addEventHandlers (const EventHandlers &eventHandlers)
EventHandlers & | getEventHandlers ()
| get the list of EventHandlers
const EventHandlers & | getEventHandlers () const
| get the const list of EventHandlers
void | addUpdateOperation (ref_ptr< Operation > op, UpdateOperations::RunBehavior runBehavior=UpdateOperations::ONE_TIME)
| add an update operation
virtual bool | advanceToNextFrame (double simulationTime=UseTimeSinceStartPoint)
virtual void | handleEvents ()
| pass the Events into any registered EventHandlers
virtual void | compile (ref_ptr< ResourceHints > hints={})
virtual bool | acquireNextFrame ()
virtual VkResult | waitForFences (size_t relativeFrameIndex, uint64_t timeout)
virtual void | assignRecordAndSubmitTaskAndPresentation (CommandGraphs commandGraphs)
void | addRecordAndSubmitTaskAndPresentation (CommandGraphs commandGraphs)
| Add command graphs creating RecordAndSubmitTask/Presentation objects where appropriate.
void | setupThreading ()
void | stopThreading ()
virtual void | update ()
virtual void | recordAndSubmit ()
virtual void | present ()
virtual void | deviceWaitIdle () const
| Call vkDeviceWaitIdle on all the devices associated with this Viewer.
void | assignInstrumentation (ref_ptr< Instrumentation > in_instrumentation)
| Convenience method for assigning Instrumentation to the viewer and any associated objects.
Public Member Functions inherited from vsg::Inherit< Object, Viewer >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T >
T * | cast ()
template<class T >
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | traverse (ConstVisitor &) const
virtual void | traverse (RecordTraversal &) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T >
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T >
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T >
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T >
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T >
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T >
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Public Attributes
ref_ptr< UpdateOperations > | updateOperations
| thread safe container for update operations
ref_ptr< AnimationManager > | animationManager
| manager for starting and running animations
ref_ptr< CompileManager > | compileManager
| compile manager provides thread safe support for compiling subgraphs
RecordAndSubmitTasks | recordAndSubmitTasks
Presentations | presentations
ref_ptr< ActivityStatus > | status
std::list< std::thread > | threads
uint64_t | frameReference = 0
| Hook for assigning Instrumentation to enable profiling of record traversal.
ref_ptr< Instrumentation > | instrumentation

## Static Public Attributes
static constexpr double | UseTimeSinceStartPoint = std::numeric_limits<double>::max()
| hint for setting the FrameStamp::simulationTime to time since start_point()

## Protected Attributes
bool | _close = false
Windows | _windows
bool | _firstFrame = true
clock::time_point | _start_point
ref_ptr< FrameStamp > | _frameStamp
UIEvents | _events
EventHandlers | _eventHandlers
bool | _threading = false
ref_ptr< FrameBlock > | _frameBlock
ref_ptr< Barrier > | _submissionCompleted

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Object, Viewer >
static ref_ptr< Viewer > | create (Args &&... args)
static ref_ptr< Viewer > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

Viewer provides high level viewer functionality for managing windows, handling events and recording and submitting command graphs for compute and rendering.

## Member Function Documentation

## ◆ advanceToNextFrame()

virtual bool vsg::Viewer::advanceToNextFrame | ( | double | simulationTime = UseTimeSinceStartPoint | ) |
| virtual

Convenience method for advancing to the next frame. Check active status, return false if viewer no longer active. If still active, poll for pending events and place them in the Events list and advance to the next frame, generate updated FrameStamp to signify the advancement to a new frame and return true.

## ◆ assignRecordAndSubmitTaskAndPresentation()

virtual void vsg::Viewer::assignRecordAndSubmitTaskAndPresentation | ( | CommandGraphs | commandGraphs | ) |
| virtual

Create RecordAndSubmitTask and Presentation objects configured to manage specified commandGraphs and assign them to the viewer. Replace any prexisting setup.

## ◆ waitForFences()

virtual VkResult vsg::Viewer::waitForFences | ( | size_t | relativeFrameIndex,
|  | uint64_t | timeout )
| virtual

call vkWaitForFence on the fences associated with previous frames RecordAndSubmitTask, a relativeFrameIndex of 1 is the previous frame, 2 is two frames ago. timeout is in nanoseconds.

The documentation for this class was generated from the following file:

- include/vsg/app/Viewer.h